'''

For how to install this script see the end of this intro.

Title: Micro tuning optimized MIDI PLAYER program, that uses one sound file to create any melody with "just" interval harmony.

Project for the A10 (final) assignment of the coursera.org web based course: Audio Signal Processing for Music Applications
by Xavier Serra at Universitat Pompeu Fabra of Barcelona and Julius O Smith at Stanford University

PROGRAM DESCRIPTION
The program converts standard midifiles to a music wav file based on just one wav-file (violin, but could be any recorded one-pitch sound)
The music file can be played in different type of scales: Following scales are provided:
    *  "tempered" The standard tempered scale based on the twelfth root of two 
    *  "pythagorean" A Pythagorean scale based on the circle of pure fifths.
    *  "just"  A just scale https://en.wikipedia.org/wiki/Just_intonation#Five-limit_tuning based Her you have perfect fifth, (and therby perfect fourths) and perfect minor and major thirds
    *  "ptolomy_frygian_tc" one of Ptolomys strange scales noted down in the first century AD Phrygian tense chromatic (from Andrew Barkers "Greek Musical Writing" ISBN 052130220X )

You may configure the program so the harmony part uses "just" intervals against the melody part.    

DISCUSSION:
The program has several purposes:
* The objective of delivering a solution on the A10 assignment
* Make a sort of sampler where I can take any sound (for example my one note own violin playing) and play a midi file with that sound The sound should be nicer than the one you get out of a common
* To play midi files in not tempered scales 

I hope that the first readers of this text will appreciate the first objective :-)
I did. And you can read more about it in the following chapter about development and testing.
(I have put the instruction for installation last)

Nice sound
The second objective: I think this software makes nicer violin sound than most scoring software that I know of. 
We use the free Musescore software, which serves us very good, but we never use violin sound always piano flute or trumpet, 
when making sound files for our web site. We are mostly violins in the band, and I hope to be able to generate violin files 
When you play fiddle you want to avoid the classic sound
The sound generated by this script is by no means perfect, but it is better than what we are used to. 
I am also an jazz amateur and a great fan of Band in a Box software. ANd I must admit that my script does not get close to their sound, but now I know how they do things.
And that is good learning. Thank you Xaveier Sera for making such a fantastic course

I have prepared the code so I can use more sounds. I am here thinking of two sounds for each string, one loose string, and maybe one for short notes and one for long notes.
For the purpose of playing in non-tempered scales, however, using just one base tone (a4_mono.wav). So I am sure that the frequency I measure on the output is the frequency I calculated it should be. And it is!


Different scales

The third objective is to investigate if it possible to here the difference on tune which is played tempered or one which is played with "just" tuning. 
I have also implemented Pythagorean 


Still it is nice that I now have a tool which can produce melodies in just tuning.
Actually I fancy tempered, since it is what western Europeans have been doing for the last 300 years, and what you have to do when you play with other instruments than violins.
But i very strongly promote just tuning for tuning your violins.
The difference on a just and a tempered violin is only 2 cent (two hundreds of a semitone ) or 0.75 Hz at 660 Hz (E-string one fifth above the A440 string)
For me it is a litle difficult to hear, so I use a tuner with cent display, an tune the fifth 2 cents greater. It works very well. 
I have been interested in micro tuning for many years.
It is widly understood among violinists that you should not use a normal tuner to tune the 4 strings, but if you cant hear the just tones, you may have to do it. When HTML5 came out some 7 years ago I made 
a tone generator, that could generate just intervals, with a FFT analyzer. I have been working as a sales man  for Bruel & Kjaer company selling FFT analyzers for 15 - 30.000 $, now I could make my own for free.
Amazing. With this analyzer I suddenly understood the Physics of harmonies. Music is when the upper harmonic meets. Maybe you will share my understanding playing with my tool: 
http://oleviolin.com/violin/generator/en/GenHarm.htm I have just translated it (from Danish to English). Ptolomy talks about Epimoric intervals in string length they are 1/2 (octave) 2/3 (fifth) and so on n/(n+1)
But it is easier to calculate in freqnecies 1/(string length) 2/1 octave, 3/2 Fifth, 4/3 Fourth, 5/4 Major third 6/5 Minor third. The "just" scale is a scale that maximises the use of these exact intervals.
But why? Look at my generator and you get the answer. You can hear and see the beat-frequencies that appear where the harmonics meat at the A and E When you gradually go from 


DEVELOPMENT and TESTING CONSIDERATIONS
I have learnt a lot during the week I have been working on making this music generator, both on programming and music theory.
I started 12 days ago, finding out whether I could read a midi file, so you found the py_midicsv. I have been working with midi before, but never in python. 
Merging into a common file was not a big problem. Of course I wanted to do as litle impact as possible of the SMTG file, so I chose the hpsTransformation_function.py as my point of entry, 
and made sure that the file got "decorated" in a way that file could still be used for other purposes. Two of the HPS three functions are used. Harmonic transformation, and time transformation.
With these transformations I can use one sound for playing any melody.

Originally I thought of just making the melody and select the melody track during setup, but when I relized that I could not hear the difference on just and tempered.
So I had to plan for being able to play harmonies. 
The scandinavian fiddle music midi files I use are from a collection of music my band has been collecting for the last 24 years at https://spillefolk.dk 
There is presently more than 2800 sheets of music in our collection, and I have built interfaces in for playing the midifiles generated by our scoring software
YouTube and our own mp3 recordings together with the files, I have used the slow, down functions available in the browsers, and together with an A/B technique for making 
it easier to practice and learn the melodies. But there is a problem that when you apply a fiddle sound, it sounds quite awfull. The producers of scoring programs have a classical approach to violin.
OK the piano sound is better, but it would be nice to get a better sound. I think the objective of getting a better sound is fullfilled with this script.
The sound is not perfect, but it is better. 
I had some problems with the sound quality of the short notes, I tried to solve it by reading in two sounds, one for short notes, one for longer. But I gave it up, 
(there is still some reminence in the software from this trial, using arrays for the input sound, who knows, in the future I might be able to use that feature)
But for the means of getting the microtuning right and verified, I prefered the use of just one note. The note is taken on an open string. I did  not know how to measure the frequency in the start.
Used 12 hours to installe Essentia, (until I relized that I was using Ubunto 18.04, when upgrading to 20.04 there was no problem. But I could not get use that tool ) I realized that in my old Cool Edit Pro
software the function was built into the spectra. Here I could verify that my script was producing the cent offset expected of a just scale. 0, 
(Solafegio, frequency multiplier, Cent value) (Do, 1/1, 0), (Re, 9/8, 4), (Mi, 5/4, -14), (Fa, 4/3, -2), (Sol,3/2,2), (La,5/3,-16), (Ti,15/8,-12), (Do,2/1, 0)
I was a litle concerned that the 512 lines FFT resolution used by the synthesis in the hpsModelSynth function would not be able to catch the micro frequencies
required, but my measurements show that I am wrong.
Now I could generate the music in the just scale and in the tempered scale, but could I hear the difference: No
So I had to extend the script to generate the second part harmony. 
Here I sometimes could hear the difference, 
But there is a problem with the just scale, not all intervals are just.
The intervals from Re to Fa and Re to La (the II-chord D-minor chord in C-major or the E-minor chord in D-major)
Are not just. So what to do about that?


Eureka!!!
I got an idea, that I would not have gotten if I was not required to write this script for this course!! 
(Eureka is the old greek exclamation that Archimedes made - according to the legend running nude around in the town of Syracuse - when inventing the law of boyancy, that got his name - it means "I found it")
What do the barber shop people do when they sing justly in tune. They know nothing about just scales, just that things sound right when they listen too each other
Could I change the script so the harmony just "listened to the first voice". You may comment that it should be the first voice listenening to the harmony.
But having the harmonies listening to the first voice has several advantages. In our band we have a lot of intruments playing the first voice.
Some of them like Accoredens are  tempered tuned and that cannot change, after all tempered tuning has several advantages demonstrated 300 years ago by J.S. Bach,
when he wrote "Das Wohltemperirte Klavier". But those few violins making harmonies, they can play their harmonies justly against the rest of us, and we can stop the silly discussion
"Should you play justly or tempered?". That is a Salomonic solution to a problem, that I never had considered before. It will solve a lot of conflicts, I can tell you!!
So I am a happy man today presenting my litle script.
The rules say, that I can only one melody. I have chosen a Swedish folk melody (Boda Polska) called J&ouml;ns Lars Far. Where my fiddle friend has just composed a very nice harmony. 

Version 2.0 of the script.
(there should always be some feature left for version 2)
The Boda polska should be played with a special rythm wich cannot be notaded, where the second beat (out of three) comes a litle early.
I would like to (with Essentia) analyze the different dialects in sweden (especially the small town of Boda) for where the beat should be and build the different beats of the dialects
I would like to build stereo mp3 files with the melody in the Left channel and the Harmony in the Right channel (so you can practice one of the parts, by taking off one earphone)
An automatic feature for making all the 2800 midi-files of our collection.
Bying one note from a good scandinavian folk violinist before we do that collection. This can be considered as a Covid-19 support to that muscisian.




INSTRUCTIONS FOR INSTALLATION

REQUIREMENTS
You need to install https://github.com/MTG/sms-tools
Please read the How to use section on how to install dependencies, and complie the c-libraries. (do exatctly as indicated in the readme file at github)
Furthermore:
You need to install the py_midicsv library used for converting a midifile
use: 
pip install py_midicsv          (or pip3 install py_midicsv)
You need to provide one wav file, which consists a tone of an istrument, and you need to fill out the config.json.

mididir":"./mid/"                       # location of the midifiles
"readall":""                            # if True, reads all (unhandled) files in the midi directory - not yet implemented
"softwaredir":"../../software/",        # location of the software directory of sms-tools relative to the installation of three python files
"wavefile":"./a4_mono.wav"              # The Wave file used for making the music
"wavetuning":"439.0"                    # It is difficult to play a good sound on the violin and at the same time be perfect in tune
                                        # therefore I insted put a factor in which compensate for the actual tuning of the input sound
"shortwavefile":"./a4short.wav"         # Especially the very short notes are not sounding very good, I realize that when you play fiddle 
                                        # you tend to slur short notes (I.e. playing them togher) So proloing the midi values with 0.1 second if below 0.4 seconds of lenth did the trick of getting more natural short notes
"shortlimit_sec":"0.4",                 # This is the parameter setting for when a note is considered short and need a prolongation
                                        # The prolonged note will just mix into the attack of next note where it is not heard. I am prolong the total length with 0.5 second in order not loosing any notes in the end.
"wave_midno":69,                        # Pitch in standard MIDI (decimal) of the input wavefile 69 correspnds to a4
                                        # 60 is "keyhole C" on the piano
"midifile":"po-jzznslarsfar"            # Midifile to convert (without .mid file extension).
                                        # a collection of scandinavnian fiddle tunes collected over the last 24 years
"scaletype":"just",                     # the tempered scale type is based on the twelfth root of 2, 
                                        # while the other scale types are based on Nominator/Denominator (T/N) numbers
                                        "just_convert_harmony":"yup",
"harm_scaletype":"just"                 # in the latest version it ispossible to convert the harmonies (that is second and third part of the midifile) with respect to the first part

"possible_scale_types":["tempered","just","pythagorean","ptolomy_frygian_tc"]

                                        # it is nice to have the different options available in the file, I could use it to check my spelling of the scaletype, (but that is on the todo-list for now :-)                                          
"uselastnote":"True"                    # Set to "" (empty string) for using the key set in midi. Note this works only for major keys. For minor or other modes set to ""
                                        # key is important for just scales, however the key written into the midi-file does not cover
                                        # minor (nor dorian nor mixolydian sometimes used in the fiddle tunes), Reading the last note  is a good alternative, but it is not perfect 
                                        # there are melodies not ending in the root of the scale
                                        # Some tunes-types shift and are always in major key, here you should use the uselastnote setting False:
                                        # just before a key shift and in the end of the melody. 
                                        # THe melody track can be identified as the track having the highest pitch

FILES
The project consists of 4 python files  
midi_player.py  (this file)
read_midi.py     (Reads the midi file)
converters.py       (converts ticks to seconds and Midi numbers to a factor to multiply the frequency with)
hpsTransformation_function.py a slightly decorated (modified) version of the file. The decoration is done so the file will still work
in the /sms-tools/software/transformations_interface directory But if you want to test, please for safety reason make a backup of your hpsTransformation_function.py before replacing it
I have supplied the a4_mono.wav file which is me playing on the A-string. I used a day to install Essentia, in order to determine the frequency of the input and the generated tones, when
I relaized that an old cool-edit program did exactly that. It is difficult to play a note exactly in 440. When I tune my instrument I use tuner and I tune on the loos string. The fifth are 
tuned 2 cent lower in order to get the perfect fifth, it really matters, you get a much better sound of a violin tuned in perfect fifths. 

RUNNING THE SCRIPT
make sure you have placed the midi-file into the ./mid/ subdirectory. run the command
>>python3 midi_player.py
The conversion is slow You will se quite a lot of debug information keeping your mind calm that something is happening.
The debug information will be collected into the output-FILES directory.
aspma-16-results
'''

import sys, os
from scipy.io.wavfile import read
import numpy as np
import json
import pprint as pp
import py_midicsv as pm
sys.path.append(os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../software/models/',
'../../software/transformations/','../../software/transformations_interface/'))
import read_midi as RM
import hpsTransformations_function as hT
import hpsModel as HPS
import hpsTransformations as HPST
import harmonicTransformations as HT
import utilFunctions as UF
import pprint as pp
import converters as convert


class Midi_player:
    def __init__(self):
        docu=[]                                                                                        #self.parent=parent
        midiFile,config=self.readConfig() 
        str_out=str(config)
        self.wav_idx=0
                                                                                                #Read in the configuration file
        self.ReadWavs()                                                                         #Read in the wav file
        if not os.path.isfile(midiFile):
            print(" ***************************** ERROR *************" )
            print(str(midiFile)+" DOES NOT EXIST")
            print(" ***************************** Please check config.json*************" )
            exit() 
        midi_sequences,TrackLength,TpQ,Tempos = RM.readmidi(midiFile)                           #Read in the midi file
  
        first_voice_idx,secondVocies=self.find_First_voice(midi_sequences)
        print("first_voice_idx:"+str(first_voice_idx))
        first_midi_sequence=midi_sequences[first_voice_idx]                                     #The midi files consist of several voices 
        print("midi_len:"+str(len(first_midi_sequence)))
                                                                                                #event={"startSec":startSec,"lenSec":lenSec,"factor":factor}        
                                                                                                # Convert the midi sequences to time in seconds
                                                                                                # and frequency multiplication of the input sound         
        first_sequence,TotalTime,lastnote,docu=convert.convert_sequence(first_midi_sequence,TpQ,TrackLength,Tempos,self.scaletype,self.wave_midno,self.uselastnote)
        print("seqlen"+str(len(first_sequence)))

        fs=self.fs[0]
        NoOfSamples=int((TotalTime+0.5)*fs)                                                     #Make the output sound a litle bit longer, to avoid truncate in the end of the song.
        print("NoOfSamples:"+str(NoOfSamples))
        y=np.zeros(NoOfSamples)                                                                 # Make the  output sound array
        str_out+="\nLastNote:"+str(lastnote)+"\n"
        marker="first:"
        y,str_out=self.makeVoice(y,first_sequence,str_out,fs,marker,"")

        self.makeSound(y,fs,str_out,'1',docu)
        voic=1
        wl=self.wave_length[self.wav_idx]    
        for voice in secondVocies:
            voic+=1                                                                             #for naming the voice
            z=np.zeros(NoOfSamples)   
                                                                   # the z output is for the second voice alone
            if self.just_convert_harmony:
                tuning_factor=440/float(self.wavetuning)  
                sequence,docu=convert.convert_second_harmony(voice,first_midi_sequence,first_sequence,self.harm_scaletype,self.wave_midno,tuning_factor,TpQ,wl)
                
            else:
                sequence,TotalTime,lastnote,docu=convert.convert_sequence(voice,TpQ,TrackLength,Tempos,self.scaletype,self.wave_midno,self.uselastnote)
            
            marker="second:"+str(voic)
            z,str_out=self.makeVoice(z,sequence,str_out,fs,marker,self.just_convert_harmony)                         #make second voice alone
            marker="first+second:"
            self.makeSound(z,fs,str_out,str(voic),docu)
            y,str_out=self.makeVoice(y,sequence,str_out,fs,marker,self.just_convert_harmony)                         #make
            self.makeSound(y,fs,str_out,'',docu)



        
  

    def makeSound(self,y,fs,str_out,part,docu):
        print("writing:"+part)
        max=y.max()
        listening=""
        if self.just_convert_harmony:
            listening="_Harmony_listening_"
    
        if max!=0:                 
            reduction=0.80/max   
            y=y*reduction                                                     # auto scale sound to 80% of max (hereby avoid clipping)    
            str_out+="\nMaximum before scaling:"+str(max)   
        max=y.max()
 
        outpath='output_sounds/'                                            #write the finished wav file
        os.makedirs(outpath, exist_ok=True)  
        outFile = outpath + self.midifile +"_"+self.scaletype +listening + part+".wav"         
        UF.wavwrite(y,fs,outFile) 
        doc_outpath= outpath+"txt/"
        os.makedirs(doc_outpath, exist_ok=True) 
        f = open(doc_outpath+self.midifile +"_"+self.scaletype +listening+ part+".txt" , "w")
        f.write(str_out)
        for doc in docu:
            str_out+="\n"+str(doc)        
        f.write(str_out)
        f.close()

    def makeVoice(self,y,sequence,str_out,fs,marker,harm):
        for note in sequence:               
            tone=self.makeNote(note,harm)                                        #Make the tone array                                 
            
            startSec=float(note["startSec"])                               #Select the start in seconds
            startIdx=int(startSec*fs)                                      #Start index in the output arry
            idxLen=tone.shape[0]                                           #Length in samples
            endIdx=int(startIdx+idxLen)                                    #End index
            doc_str=marker+str(note) +" endIdx: "+str(endIdx)+ " idx " + str(endIdx-startIdx) + "" " len " +str(tone.shape[0] )
            print(doc_str)
            
            b=y[startIdx:endIdx]                                           #Select from the output sound array 
            if(b.shape==tone.shape):
                c=b+tone               
                y[startIdx:endIdx]=c                                          #Update the output array                                                        
                str_out+=doc_str+"\n"
            else:
                print("Warning: skipped last note:"+str(tone.shape)+' '+str(b.shape))

        return y, str_out    

    def makeNote(self,note,harm=""):         
    
            lenSec=float(note["lenSec"])                                    #Length in seconds
            wl=self.wave_length[self.wav_idx]                               #length of the input wav file  
            freqStretching=np.array([0, 1,wl,1])                            #No frequency streaching                         
            if harm:
                freqScaling=np.array(note['factor_array'])
            else:
                factor=float(note["factor"])                                    #the factor is what you should multiply the input note with to get the right frequency

            vel=int(note["vel"])
            if lenSec<self.shortlimit_sec:
                self.wav_idx=0
                lenSec+=0.1
            else:
                self.wav_idx=0
                                 

                
            if harm:
                factor=note["factor_array"]
            else:
                factor=factor*440/float(self.wavetuning)                                
                freqScaling=np.array([0, factor,wl,factor])                     #Frequency Scaling with the factor
            timeScaling=np.array([0,0,wl,lenSec])                           #Time scaling in seconds 
            
            #Make the tranformation using the (modified)  hpsTransformations_function.py 
            y=hT.transformation_synthesis( self.inputFile[self.wav_idx]   , self.fs[self.wav_idx]   , self.hfreq[self.wav_idx]   , self.hmag[self.wav_idx], self.mYst[self.wav_idx] ,freqScaling,freqStretching,1,timeScaling,False  )
            y=y*float(vel/128)
            return y

    def find_First_voice(self,sequences):
        mid_means=[]
        i=0
        for seq in sequences:
            mid_seq=[]
            for note in seq:
               
                if note["function"]=="note":
                    
                    #print(str(note))
                    mid=int(note['mid'])
                    mid_seq.append(mid)
            
            if len(mid_seq)>0:
                print(len(mid_seq))
                mid_arr=np.array(mid_seq)
                mean=np.mean(mid_arr)
                print("mean:"+str(mean)+' '+str(i))
                mid_means.append((mean,i))   
            i+=1    
        secondVoices=[]
        means=np.array(mid_means)
        print(str(means.shape[0]))
        if means.shape[0]==1:
            first_voice_idx=int(means[0,1])
        else:
            first_voice_idx=int(np.argmax(means, axis=0)[0])
        print("first_voice_idx:"+str(first_voice_idx))        
        for x in mid_means: 
            if x[1]!=first_voice_idx:
                secondVoices.append(sequences[x[1]])

        return first_voice_idx,secondVoices

    def readConfig(self):                                                  #Read the setup
        configfile="config.json"
        with open(configfile) as config_file:
            config=json.load(config_file)
            pp.pprint(config)
            config_file.close()
        self.softwaredir=config["softwaredir"]
        self.mididir=config["mididir"]    
        self.wavefile=config["wavefile"]
        self.shortwavefile=config["shortwavefile"]
        self.scaletype=config["scaletype"]
        self.midifile=config["midifile"]
        self.wave_midno=config["wave_midno"]
        self.shortlimit_sec=float(config["shortlimit_sec"])
        self.readall=config["readall"]
        self.uselastnote=config["uselastnote"]
        self.possible_scale_types=config["possible_scale_types"]
        self.harm_scaletype=config["harm_scaletype"]
        self.just_convert_harmony=config["just_convert_harmony"]     #Convert second voice (microtunal correctly) with respect to first voice and not with respect to root
        OK=False
        for scale in self.possible_scale_types:
            if scale==self.scaletype:
                OK=True

        if not OK:            
            print("\n\n*************** ERROR ************")
            print("\nSCALETYPE: "+self.scaletype+" does NOT Exist\n")
            print("***************Exiting ***********\n\n")
            exit()        




        self.wavetuning=config["wavetuning"]
        midiFile=self.mididir+"/"+self.midifile +".mid"
        return midiFile , config                                                       #Deliver a pointer to the midi file
    
        



    def ReadWavs(self):
        #Use the analysis function of the modified hpsTransformations_function.py 
        size=2
        self.inputFile=[0]*size
        self.fs=[0]*size
        self.hfreq=[0]*size 
        self.hmag=[0]*size
        self.mYst=[0]*size
        self.wave_length=[0]*size        

        self.inputFile[0] , self.fs[0], self.hfreq[0], self.hmag[0], self.mYst[0],self.wave_length[0] = hT.analysis(inputFile=self.wavefile,window='hamming', M=601, N=2048, t=-90,NormalUse=False)
        '''
        self.inputFile[1], self.fs[1], self.hfreq[1], self.hmag[1], self.mYst[1],self.wave_length[1] = hT.analysis(inputFile=self.shortwavefile,window='hamming', M=601, N=2048, t=-90,NormalUse=False)
        
        if self.fs[0]!=self.fs[1]:
            print("Input files does not match!!")
            print(" EXITING")
            exit()
        '''             


t=Midi_player()